font.h File Reference

## Data Structures

struct | MFont
| Type of fonts. More...
struct | MFontPropertyTable
struct | MRealizedFont
struct | MFLTFontForRealized
struct | MFontScore
struct | MFontList
struct | MFontDriver
struct | MFontCapability

## Macros

#define | FONT_PROPERTY(font, n) (mfont__property_table[(n)].names[(font)->property[(n)]])
#define | MFONT_INIT(font) memset ((font), 0, sizeof (MFont))

## Typedefs

typedef struct MFontEncoding | MFontEncoding
typedef unsigned | OTF_Tag

## Enumerations

enum | MFontProperty { MFONT_FOUNDRY , MFONT_FAMILY , MFONT_WEIGHT , MFONT_STYLE , MFONT_STRETCH , MFONT_ADSTYLE , MFONT_REGISTRY , MFONT_RESY , MFONT_SIZE , MFONT_SPACING , MFONT_PROPERTY_MAX = MFONT_SIZE }
enum | MFontType { MFONT_TYPE_SPEC , MFONT_TYPE_OBJECT , MFONT_TYPE_REALIZED , MFONT_TYPE_FAILURE }
enum | MFontSource { MFONT_SOURCE_UNDECIDED = 0 , MFONT_SOURCE_X = 1 , MFONT_SOURCE_FT = 2 }
enum | MFontSpacing { MFONT_SPACING_UNDECIDED , MFONT_SPACING_PROPORTIONAL , MFONT_SPACING_MONO , MFONT_SPACING_CHARCELL }
enum | MFontOpenTypeTable { MFONT_OTT_GSUB , MFONT_OTT_GPOS , MFONT_OTT_MAX }

## Functions

int | mfont__flt_init ()
void | mfont__flt_fini ()
void | mfont__free_realized (MRealizedFont *rfont)
int | mfont__match_p (MFont *font, MFont *spec, int prop)
int | mfont__merge (MFont *dst, MFont *src, int error_on_conflict)
void | mfont__set_spec_from_face (MFont *spec, MFace *face)
MSymbol | mfont__set_spec_from_plist (MFont *spec, MPlist *plist)
int | mfont__has_char (MFrame *frame, MFont *font, MFont *spec, int c)
unsigned | mfont__encode_char (MFrame *frame, MFont *font, MFont *spec, int c)
int | mfont__get_glyph_id (MFLTFont *font, MFLTGlyphString *gstring, int from, int to)
MFont * | mfont__select (MFrame *frame, MFont *font, int max_size)
MFontList * | mfont__list (MFrame *frame, MFont *spec, MFont *request, int limited_size)
MRealizedFont * | mfont__open (MFrame *frame, MFont *font, MFont *spec)
void | mfont__get_metric (MGlyphString *gstring, int from, int to)
int | mfont__get_metrics (MFLTFont *font, MFLTGlyphString *gstring, int from, int to)
void | mfont__set_property (MFont *font, enum MFontProperty key, MSymbol val)
int | mfont__split_name (char *name, int *property_idx, unsigned short *point, unsigned short *resy)
int | mfont__parse_name_into_font (const char *name, MSymbol format, MFont *font)
MPlist * | mfont__encoding_list (void)
MFontCapability * | mfont__get_capability (MSymbol sym)
int | mfont__check_capability (MRealizedFont *rfont, MSymbol capability)
unsigned | mfont__flt_encode_char (MSymbol layouter_name, int c)
int | mfont__flt_run (MGlyphString *gstring, int from, int to, MRealizedFace *rface)

## Variables

MFontPropertyTable | mfont__property_table [MFONT_REGISTRY+1]
MSymbol | Mlayouter
MSymbol | Miso8859_1
MSymbol | Miso10646_1
MSymbol | Municode_bmp
MSymbol | Municode_full
MSymbol | Mapple_roman

## Macro Definition Documentation

## FONT_PROPERTY

#define FONT_PROPERTY | ( |  | font,
|  |  | n
| ) |  | (mfont__property_table[(n)].names[(font)->property[(n)]])

## MFONT_INIT

#define MFONT_INIT | ( |  | font | ) | memset ((font), 0, sizeof (MFont))

## Typedef Documentation

## MFontEncoding

typedef struct MFontEncoding MFontEncoding

## OTF_Tag

typedef unsigned OTF_Tag

## Enumeration Type Documentation

## MFontProperty

enum MFontProperty

Enumerator
MFONT_FOUNDRY |
MFONT_FAMILY |
MFONT_WEIGHT |
MFONT_STYLE |
MFONT_STRETCH |
MFONT_ADSTYLE |
MFONT_REGISTRY |
MFONT_RESY |
MFONT_SIZE |
MFONT_SPACING |
MFONT_PROPERTY_MAX |

## MFontType

enum MFontType

Enumerator
MFONT_TYPE_SPEC |
MFONT_TYPE_OBJECT |
MFONT_TYPE_REALIZED |
MFONT_TYPE_FAILURE |

## MFontSource

enum MFontSource

Enumerator
MFONT_SOURCE_UNDECIDED |
MFONT_SOURCE_X |
MFONT_SOURCE_FT |

## MFontSpacing

enum MFontSpacing

Enumerator
MFONT_SPACING_UNDECIDED |
MFONT_SPACING_PROPORTIONAL |
MFONT_SPACING_MONO |
MFONT_SPACING_CHARCELL |

## MFontOpenTypeTable

enum MFontOpenTypeTable

Enumerator
MFONT_OTT_GSUB |
MFONT_OTT_GPOS |
MFONT_OTT_MAX |

## Function Documentation

## mfont__flt_init()

int mfont__flt_init | ( |  | ) |

## mfont__flt_fini()

void mfont__flt_fini | ( |  | ) |

## mfont__free_realized()

void mfont__free_realized | ( | MRealizedFont * | rfont | ) |

## mfont__match_p()

int mfont__match_p | ( | MFont * | font,
|  | MFont * | spec,
|  | int | prop
| ) |  |

## mfont__merge()

int mfont__merge | ( | MFont * | dst,
|  | MFont * | src,
|  | int | error_on_conflict
| ) |  |

## mfont__set_spec_from_face()

void mfont__set_spec_from_face | ( | MFont * | spec,
|  | MFace * | face
| ) |  |

## mfont__set_spec_from_plist()

MSymbol mfont__set_spec_from_plist | ( | MFont * | spec,
|  | MPlist * | plist
| ) |  |

## mfont__has_char()

int mfont__has_char | ( | MFrame * | frame,
|  | MFont * | font,
|  | MFont * | spec,
|  | int | c
| ) |  |

## mfont__encode_char()

unsigned mfont__encode_char | ( | MFrame * | frame,
|  | MFont * | font,
|  | MFont * | spec,
|  | int | c
| ) |  |

## mfont__get_glyph_id()

int mfont__get_glyph_id | ( | MFLTFont * | font,
|  | MFLTGlyphString * | gstring,
|  | int | from,
|  | int | to
| ) |  |

## mfont__select()

MFont* mfont__select | ( | MFrame * | frame,
|  | MFont * | font,
|  | int | max_size
| ) |  |

## mfont__list()

MFontList* mfont__list | ( | MFrame * | frame,
|  | MFont * | spec,
|  | MFont * | request,
|  | int | limited_size
| ) |  |

## mfont__open()

MRealizedFont* mfont__open | ( | MFrame * | frame,
|  | MFont * | font,
|  | MFont * | spec
| ) |  |

## mfont__get_metric()

void mfont__get_metric | ( | MGlyphString * | gstring,
|  | int | from,
|  | int | to
| ) |  |

## mfont__get_metrics()

int mfont__get_metrics | ( | MFLTFont * | font,
|  | MFLTGlyphString * | gstring,
|  | int | from,
|  | int | to
| ) |  |

## mfont__set_property()

void mfont__set_property | ( | MFont * | font,
|  | enum MFontProperty | key,
|  | MSymbol | val
| ) |  |

## mfont__split_name()

int mfont__split_name | ( | char * | name,
|  | int * | property_idx,
|  | unsigned short * | point,
|  | unsigned short * | resy
| ) |  |

## mfont__parse_name_into_font()

int mfont__parse_name_into_font | ( | const char * | name,
|  | MSymbol | format,
|  | MFont * | font
| ) |  |

## mfont__encoding_list()

MPlist* mfont__encoding_list | ( | void |  | ) |

## mfont__get_capability()

MFontCapability* mfont__get_capability | ( | MSymbol | sym | ) |

## mfont__check_capability()

int mfont__check_capability | ( | MRealizedFont * | rfont,
|  | MSymbol | capability
| ) |  |

## mfont__flt_encode_char()

unsigned mfont__flt_encode_char | ( | MSymbol | layouter_name,
|  | int | c
| ) |  |

## mfont__flt_run()

int mfont__flt_run | ( | MGlyphString * | gstring,
|  | int | from,
|  | int | to,
|  | MRealizedFace * | rface
| ) |  |

## Variable Documentation

## mfont__property_table

MFontPropertyTable mfont__property_table[MFONT_REGISTRY+1]

extern

## Mlayouter

MSymbol Mlayouter

extern

## Miso8859_1

MSymbol Miso8859_1

extern

## Miso10646_1

MSymbol Miso10646_1

## Municode_bmp

MSymbol Municode_bmp

## Municode_full

MSymbol Municode_full

## Mapple_roman

MSymbol Mapple_roman

extern